Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 15242)
@@ -20,7 +20,8 @@
 #endregion
 
-using System.Collections.Generic;
+using System;
 using System.Drawing;
 using System.Linq;
+using HeuristicLab.Analysis;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,22 +30,19 @@
   [Item("Histogram", "Represents the histogram grid.")]
   public class HistogramContent : PreprocessingChartContent {
-
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Statistics; }
     }
-    private const int MAX_DISTINCT_VALUES_FOR_CLASSIFCATION = 20;
 
-    private int classifierVariableIndex = 0;
+    public string GroupingVariableName { get; set; }
 
-    public int ClassifierVariableIndex {
-      get { return this.classifierVariableIndex; }
-      set { this.classifierVariableIndex = value; }
-    }
-    public bool IsDetailedChartViewEnabled { get; set; }
+    public int Bins { get; set; }
+    public bool ExactBins { get; set; }
 
+    public LegendOrder Order { get; set; }
 
     public HistogramContent(IFilteredPreprocessingData preprocessingData)
       : base(preprocessingData) {
-      AllInOneMode = false;
+      Bins = 10;
+      ExactBins = false;
     }
 
@@ -56,19 +54,47 @@
     }
 
-    public IEnumerable<string> GetVariableNamesForHistogramClassification() {
-      List<string> doubleVariableNames = new List<string>();
+    public static DataTable CreateHistogram(IFilteredPreprocessingData preprocessingData, string variableName, string groupingVariableName, DataTableVisualProperties.DataTableHistogramAggregation aggregation, LegendOrder legendOrder = LegendOrder.Alphabetically) {
+      var dataTable = new DataTable {
+        VisualProperties = { Title = variableName, HistogramAggregation = aggregation },
+      };
 
-      //only return variable names from type double
-      for (int i = 0; i < PreprocessingData.Columns; ++i) {
-        if (PreprocessingData.VariableHasType<double>(i)) {
-          double distinctValueCount = PreprocessingData.GetValues<double>(i).GroupBy(x => x).Count();
-          bool distinctValuesOk = distinctValueCount <= MAX_DISTINCT_VALUES_FOR_CLASSIFCATION;
-          if (distinctValuesOk)
-            doubleVariableNames.Add(PreprocessingData.GetVariableName(i));
-        }
+      if (string.IsNullOrEmpty(groupingVariableName)) {
+        var row = PreprocessingChartContent.CreateDataRow(preprocessingData, variableName, DataRowVisualProperties.DataRowChartType.Histogram);
+        row.VisualProperties.IsVisibleInLegend = false;
+        dataTable.Rows.Add(row);
+        return dataTable;
       }
-      return doubleVariableNames;
+
+      int variableIndex = preprocessingData.GetColumnIndex(variableName);
+      var variableValues = preprocessingData.GetValues<double>(variableIndex);
+      int groupVariableIndex = preprocessingData.GetColumnIndex(groupingVariableName);
+      var groupingValues = Enumerable.Empty<string>();
+
+      if (preprocessingData.VariableHasType<double>(groupVariableIndex)) {
+        groupingValues = preprocessingData.GetValues<double>(groupVariableIndex).Select(x => x.ToString());
+      } else if (preprocessingData.VariableHasType<string>(groupVariableIndex)) {
+        groupingValues = preprocessingData.GetValues<string>(groupVariableIndex);
+      } else if (preprocessingData.VariableHasType<DateTime>(groupVariableIndex)) {
+        groupingValues = preprocessingData.GetValues<DateTime>(groupVariableIndex).Select(x => x.ToString());
+      }
+
+      var groups = groupingValues.Zip(variableValues, Tuple.Create).GroupBy(t => t.Item1, t => t.Item2);
+
+      if (legendOrder == LegendOrder.Alphabetically)
+        groups = groups.OrderBy(x => x.Key, new NaturalStringComparer());
+
+      foreach (var group in groups) {
+        var classRow = new DataRow {
+          Name = group.Key,
+          VisualProperties = {
+              ChartType = DataRowVisualProperties.DataRowChartType.Histogram,
+              IsVisibleInLegend = !string.IsNullOrEmpty(groupingVariableName)
+            }
+        };
+        classRow.Values.AddRange(group);
+        dataTable.Rows.Add(classRow);
+      }
+      return dataTable;
     }
-
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 15242)
@@ -26,6 +26,7 @@
 namespace HeuristicLab.DataPreprocessing {
 
-  [Item("LineChart", "Represents the line chart grid.")]
+  [Item("Line Chart", "Represents the line chart grid.")]
   public class LineChartContent : PreprocessingChartContent {
+    public bool AllInOneMode { get; set; }
 
     public static new Image StaticItemImage {
@@ -35,8 +36,10 @@
     public LineChartContent(IFilteredPreprocessingData preprocessingData)
       : base(preprocessingData) {
+      AllInOneMode = true;
     }
 
     public LineChartContent(LineChartContent content, Cloner cloner)
       : base(content, cloner) {
+      this.AllInOneMode = content.AllInOneMode;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/ManipulationContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/ManipulationContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/ManipulationContent.cs	(revision 15242)
@@ -28,21 +28,16 @@
   [Item("Manipulation", "Represents the available manipulations on a data set.")]
   public class ManipulationContent : Item, IViewShortcut {
-
-    private ManipulationLogic manipulationLogic;
-    private SearchLogic searchLogic;
-    private FilterLogic filterLogic;
-
-    public ManipulationLogic ManipulationLogic { get { return manipulationLogic; } }
-    public SearchLogic SearchLogic { get { return searchLogic; } }
-    public FilterLogic FilterLogic { get { return filterLogic; } }
-
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Method; }
     }
 
-    public ManipulationContent(ManipulationLogic theManipulationLogic, SearchLogic theSearchLogic, FilterLogic theFilterLogic) {
-      manipulationLogic = theManipulationLogic;
-      searchLogic = theSearchLogic;
-      filterLogic = theFilterLogic;
+    public ManipulationLogic ManipulationLogic { get; private set; }
+    public SearchLogic SearchLogic { get; private set; }
+    public FilterLogic FilterLogic { get; private set; }
+
+    public ManipulationContent(ManipulationLogic manipulationLogic, SearchLogic searchLogic, FilterLogic filterLogic) {
+      ManipulationLogic = manipulationLogic;
+      SearchLogic = searchLogic;
+      FilterLogic = filterLogic;
     }
 
@@ -52,6 +47,4 @@
       return new ManipulationContent(this, cloner);
     }
-
-
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/MultiScatterPlotContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/MultiScatterPlotContent.cs	(revision 15242)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/MultiScatterPlotContent.cs	(revision 15242)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+
+  [Item("Multi Scatter Plot", "Represents a multi scatter plot.")]
+  public class MultiScatterPlotContent : ScatterPlotContent {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Performance; }
+    }
+
+    public MultiScatterPlotContent(IFilteredPreprocessingData preprocessingData)
+      : base(preprocessingData) {
+    }
+
+    public MultiScatterPlotContent(MultiScatterPlotContent content, Cloner cloner)
+      : base(content, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiScatterPlotContent(this, cloner);
+    }
+  }
+}
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 15242)
@@ -23,6 +23,8 @@
 using System.Collections.Generic;
 using System.Drawing;
+using System.Linq;
 using HeuristicLab.Analysis;
 using HeuristicLab.Common;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
@@ -30,22 +32,28 @@
 namespace HeuristicLab.DataPreprocessing {
   [Item("PreprocessingChart", "Represents a preprocessing chart.")]
-  public class PreprocessingChartContent : Item, IViewChartShortcut {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.PieChart; }
+  public class PreprocessingChartContent : Item, IViewShortcut {
+    public enum LegendOrder {
+      Alphabetically,
+      Appearance
     }
 
-    private bool allInOneMode = true;
-    public bool AllInOneMode {
-      get { return this.allInOneMode; }
-      set { this.allInOneMode = value; }
+    public static new Image StaticItemImage {
+      get { return VSImageLibrary.PieChart; }
     }
 
     private ICheckedItemList<StringValue> variableItemList = null;
     public ICheckedItemList<StringValue> VariableItemList {
-      get { return this.variableItemList; }
-      set { this.variableItemList = value; }
+      get {
+        if (variableItemList == null)
+          variableItemList = CreateVariableItemList(PreprocessingData);
+        return this.variableItemList;
+      }
     }
 
     public IFilteredPreprocessingData PreprocessingData { get; private set; }
+    public event DataPreprocessingChangedEventHandler Changed {
+      add { PreprocessingData.Changed += value; }
+      remove { PreprocessingData.Changed -= value; }
+    }
 
     public PreprocessingChartContent(IFilteredPreprocessingData preprocessingData) {
@@ -55,5 +63,4 @@
     public PreprocessingChartContent(PreprocessingChartContent content, Cloner cloner)
       : base(content, cloner) {
-      this.allInOneMode = content.allInOneMode;
       this.PreprocessingData = content.PreprocessingData;
       this.variableItemList = cloner.Clone<ICheckedItemList<StringValue>>(variableItemList);
@@ -63,7 +70,10 @@
     }
 
+    public DataRow CreateDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
+      return CreateDataRow(PreprocessingData, variableName, chartType);
+    }
 
-    public DataRow CreateDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
-      IList<double> values = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableName));
+    public static DataRow CreateDataRow(IFilteredPreprocessingData preprocessingData, string variableName, DataRowVisualProperties.DataRowChartType chartType) {
+      IList<double> values = preprocessingData.GetValues<double>(preprocessingData.GetColumnIndex(variableName));
       DataRow row = new DataRow(variableName, "", values);
       row.VisualProperties.ChartType = chartType;
@@ -71,73 +81,31 @@
     }
 
-    public List<DataRow> CreateAllDataRows(DataRowVisualProperties.DataRowChartType chartType) {
-      List<DataRow> dataRows = new List<DataRow>();
-      foreach (var name in PreprocessingData.GetDoubleVariableNames())
-        dataRows.Add(CreateDataRow(name, chartType));
-      return dataRows;
-    }
-
-    public DataRow CreateSelectedDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
-
-      IDictionary<int, IList<int>> selection = PreprocessingData.Selection;
-      int variableIndex = PreprocessingData.GetColumnIndex(variableName);
-
-      if (selection.Keys.Contains(variableIndex)) {
-        List<int> selectedIndices = new List<int>(selection[variableIndex]);
-        //need selection with more than 1 value
-        if (selectedIndices.Count < 2)
-          return null;
-
-        selectedIndices.Sort();
-        int start = selectedIndices[0];
-        int end = selectedIndices[selectedIndices.Count - 1];
-
-        DataRow rowSelect = CreateDataRowRange(variableName, start, end, chartType);
-        return rowSelect;
-      } else
-        return null;
-    }
-
-    public DataRow CreateDataRowRange(string variableName, int start, int end, DataRowVisualProperties.DataRowChartType chartType) {
-      IList<double> values = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableName));
-      IList<double> valuesRange = new List<double>();
-      for (int i = 0; i < values.Count; i++) {
-        if (i >= start && i <= end)
-          valuesRange.Add(values[i]);
-        else
-          valuesRange.Add(Double.NaN);
-      }
-
-      DataRow row = new DataRow(variableName, "", valuesRange);
-      row.VisualProperties.ChartType = chartType;
-      return row;
-    }
-
-    public List<DataRow> CreateAllSelectedDataRows(DataRowVisualProperties.DataRowChartType chartType) {
-      List<DataRow> dataRows = new List<DataRow>();
-      foreach (var name in PreprocessingData.GetDoubleVariableNames()) {
-        DataRow row = CreateSelectedDataRow(name, chartType);
-        if (row != null)
-          dataRows.Add(row);
-      }
-      return dataRows;
-    }
-
-
-    public ICheckedItemList<StringValue> CreateVariableItemList(IList<string> checkedItems = null) {
-      if (checkedItems == null) checkedItems = new string[0];
+    private static ICheckedItemList<StringValue> CreateVariableItemList(IPreprocessingData preprocessingData) {
       ICheckedItemList<StringValue> itemList = new CheckedItemList<StringValue>();
-      foreach (string name in PreprocessingData.GetDoubleVariableNames()) {
+      foreach (string name in preprocessingData.GetDoubleVariableNames()) {
         var n = new StringValue(name);
-        itemList.Add(n, checkedItems.Contains(name));
+        bool isInputTarget = preprocessingData.InputVariables.Contains(name) || preprocessingData.TargetVariable == name;
+        itemList.Add(n, isInputTarget);
       }
       return new ReadOnlyCheckedItemList<StringValue>(itemList);
     }
 
-    public event DataPreprocessingChangedEventHandler Changed {
-      add { PreprocessingData.Changed += value; }
-      remove { PreprocessingData.Changed -= value; }
+    public static IEnumerable<string> GetVariableNamesForGrouping(IPreprocessingData preprocessingData, int maxDistinctValues = 20) {
+      var variableNames = new List<string>();
+
+      for (int i = 0; i < preprocessingData.Columns; ++i) {
+        int distinctValues = Int32.MaxValue;
+        if (preprocessingData.VariableHasType<double>(i))
+          distinctValues = preprocessingData.GetValues<double>(i).GroupBy(x => x).Count();
+        else if (preprocessingData.VariableHasType<string>(i))
+          distinctValues = preprocessingData.GetValues<string>(i).GroupBy(x => x).Count();
+        else if (preprocessingData.VariableHasType<DateTime>(i))
+          distinctValues = preprocessingData.GetValues<DateTime>(i).GroupBy(x => x).Count();
+
+        if (distinctValues <= maxDistinctValues)
+          variableNames.Add(preprocessingData.GetVariableName(i));
+      }
+      return variableNames;
     }
-
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs	(revision 15242)
@@ -20,71 +20,86 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
-using System.Drawing;
 using System.Linq;
 using HeuristicLab.Analysis;
 using HeuristicLab.Common;
-using HeuristicLab.Core;
+using HeuristicLab.Visualization.ChartControlsExtensions;
 
 namespace HeuristicLab.DataPreprocessing {
 
-  [Item("ScatterPlot", "Represents a scatter plot.")]
-  public class ScatterPlotContent : PreprocessingChartContent {
+  public abstract class ScatterPlotContent : PreprocessingChartContent {
+    public string GroupingVariable { get; set; }
 
-    public string SelectedXVariable { get; set; }
-    public string SelectedYVariable { get; set; }
-    public string SelectedColorVariable { get; set; }
-
-    public ScatterPlotContent(IFilteredPreprocessingData preprocessingData)
+    protected ScatterPlotContent(IFilteredPreprocessingData preprocessingData)
       : base(preprocessingData) {
     }
 
-    public ScatterPlotContent(ScatterPlotContent content, Cloner cloner)
+    protected ScatterPlotContent(ScatterPlotContent content, Cloner cloner)
       : base(content, cloner) {
-      this.SelectedXVariable = content.SelectedXVariable;
-      this.SelectedYVariable = content.SelectedYVariable;
-      this.SelectedColorVariable = content.SelectedColorVariable;
     }
 
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Performance; }
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new ScatterPlotContent(this, cloner);
-    }
-
-    public ScatterPlot CreateScatterPlot(string variableNameX, string variableNameY, string variableNameColor = "-") {
+    public static ScatterPlot CreateScatterPlot(IFilteredPreprocessingData preprocessingData, string variableNameX, string variableNameY, string variableNameGroup = "-", LegendOrder legendOrder = LegendOrder.Alphabetically) {
       ScatterPlot scatterPlot = new ScatterPlot();
 
-      IList<double> xValues = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableNameX));
-      IList<double> yValues = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableNameY));
-      if (variableNameColor == null || variableNameColor == "-") {
-        List<Point2D<double>> points = new List<Point2D<double>>();
+      IList<double> xValues = preprocessingData.GetValues<double>(preprocessingData.GetColumnIndex(variableNameX));
+      IList<double> yValues = preprocessingData.GetValues<double>(preprocessingData.GetColumnIndex(variableNameY));
 
-        for (int i = 0; i < xValues.Count; i++) {
-          Point2D<double> point = new Point2D<double>(xValues[i], yValues[i]);
-          points.Add(point);
-        }
+      var points = xValues.Zip(yValues, (x, y) => new Point2D<double>(x, y)).ToList();
+      var validPoints = points.Where(p => !double.IsNaN(p.X) && !double.IsNaN(p.Y) && !double.IsInfinity(p.X) && !double.IsInfinity(p.Y)).ToList();
+      if (validPoints.Any()) {
+        try {
+          double axisMin, axisMax, axisInterval;
+          ChartUtil.CalculateOptimalAxisInterval(validPoints.Min(p => p.X), validPoints.Max(p => p.X), out axisMin, out axisMax, out axisInterval);
+          scatterPlot.VisualProperties.XAxisMinimumAuto = false;
+          scatterPlot.VisualProperties.XAxisMaximumAuto = false;
+          scatterPlot.VisualProperties.XAxisMinimumFixedValue = axisMin;
+          scatterPlot.VisualProperties.XAxisMaximumFixedValue = axisMax;
+        } catch (ArgumentOutOfRangeException) { } // error during CalculateOptimalAxisInterval 
+        try {
+          double axisMin, axisMax, axisInterval;
+          ChartUtil.CalculateOptimalAxisInterval(validPoints.Min(p => p.Y), validPoints.Max(p => p.Y), out axisMin, out axisMax, out axisInterval);
+          scatterPlot.VisualProperties.YAxisMinimumAuto = false;
+          scatterPlot.VisualProperties.YAxisMaximumAuto = false;
+          scatterPlot.VisualProperties.YAxisMinimumFixedValue = axisMin;
+          scatterPlot.VisualProperties.YAxisMaximumFixedValue = axisMax;
+        } catch (ArgumentOutOfRangeException) { } // error during CalculateOptimalAxisInterval 
+      }
 
-        ScatterPlotDataRow scdr = new ScatterPlotDataRow(variableNameX + " - " + variableNameY, "", points);
+
+      //No Grouping
+      if (string.IsNullOrEmpty(variableNameGroup) || variableNameGroup == "-") {
+        ScatterPlotDataRow scdr = new ScatterPlotDataRow(variableNameX + " - " + variableNameY, "", validPoints);
+        scdr.VisualProperties.IsVisibleInLegend = false;
         scatterPlot.Rows.Add(scdr);
+        return scatterPlot;
+      }
 
-      } else {
-        var colorValues = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableNameColor));
-        var data = xValues.Zip(yValues, (x, y) => new { x, y }).Zip(colorValues, (v, c) => new { v.x, v.y, c }).ToList();
-        var gradients = ColorGradient.Colors;
-        int curGradient = 0;
-        int numColors = colorValues.Distinct().Count();
-        foreach (var colorValue in colorValues.Distinct()) {
-          var values = data.Where(x => x.c == colorValue);
-          var row = new ScatterPlotDataRow(
-            variableNameX + " - " + variableNameY + " (" + colorValue + ")",
-            "",
-            values.Select(v => new Point2D<double>(v.x, v.y)),
-            new ScatterPlotDataRowVisualProperties() { Color = gradients[curGradient] });
-          curGradient += gradients.Count / numColors;
-          scatterPlot.Rows.Add(row);
-        }
+      //Grouping
+      int groupVariableIndex = preprocessingData.GetColumnIndex(variableNameGroup);
+      var groupingValues = Enumerable.Empty<string>();
+
+      if (preprocessingData.VariableHasType<double>(groupVariableIndex)) {
+        groupingValues = preprocessingData.GetValues<double>(groupVariableIndex).Select(x => x.ToString());
+      } else if (preprocessingData.VariableHasType<string>(groupVariableIndex)) {
+        groupingValues = preprocessingData.GetValues<string>(groupVariableIndex);
+      } else if (preprocessingData.VariableHasType<DateTime>(groupVariableIndex)) {
+        groupingValues = preprocessingData.GetValues<DateTime>(groupVariableIndex).Select(x => x.ToString());
+      }
+      var groups = groupingValues.Zip(validPoints, Tuple.Create).GroupBy(t => t.Item1, t => t.Item2);
+
+      if (legendOrder == LegendOrder.Alphabetically)
+        groups = groups.OrderBy(x => x.Key, new NaturalStringComparer());
+
+      foreach (var group in groups) {
+        var scdr = new ScatterPlotDataRow {
+          Name = group.Key,
+          VisualProperties = {
+            IsVisibleInLegend = true,
+            PointSize = 6
+          }
+        };
+        scdr.Points.AddRange(group);
+        scatterPlot.Rows.Add(scdr);
       }
       return scatterPlot;
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/SingleScatterPlotContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/SingleScatterPlotContent.cs	(revision 15242)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/SingleScatterPlotContent.cs	(revision 15242)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+
+  [Item("Scatter Plot", "Represents a scatter plot.")]
+  public class SingleScatterPlotContent : ScatterPlotContent {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Performance; }
+    }
+
+    public string SelectedXVariable { get; set; }
+    public string SelectedYVariable { get; set; }
+
+    public SingleScatterPlotContent(IFilteredPreprocessingData preprocessingData)
+      : base(preprocessingData) {
+    }
+
+    public SingleScatterPlotContent(SingleScatterPlotContent content, Cloner cloner)
+      : base(content, cloner) {
+      this.SelectedXVariable = content.SelectedXVariable;
+      this.SelectedYVariable = content.SelectedYVariable;
+      this.GroupingVariable = content.GroupingVariable;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SingleScatterPlotContent(this, cloner);
+    }
+  }
+}
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/StatisticsContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/StatisticsContent.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/StatisticsContent.cs	(revision 15242)
@@ -27,21 +27,18 @@
   [Item("Statistics", "Represents the statistics grid.")]
   public class StatisticsContent : Item, IViewShortcut {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Object; }
+    }
 
-    private readonly StatisticsLogic statisticsLogic;
-    public StatisticsContent(StatisticsLogic theStatisticsLogic) {
-      statisticsLogic = theStatisticsLogic;
+    public ITransactionalPreprocessingData PreprocessingData { get; private set; }
+    public StatisticsLogic StatisticsLogic { get; private set; }
+
+    public StatisticsContent(ITransactionalPreprocessingData preProcessingData, StatisticsLogic statisticsLogic) {
+      PreprocessingData = preProcessingData;
+      StatisticsLogic = statisticsLogic;
     }
 
     public StatisticsContent(StatisticsContent content, Cloner cloner)
       : base(content, cloner) {
-
-    }
-
-    public StatisticsLogic StatisticsLogic {
-      get { return statisticsLogic; }
-    }
-
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Object; }
     }
 
@@ -51,8 +48,7 @@
 
     public event DataPreprocessingChangedEventHandler Changed {
-      add { statisticsLogic.Changed += value; }
-      remove { statisticsLogic.Changed -= value; }
+      add { StatisticsLogic.Changed += value; }
+      remove { StatisticsLogic.Changed -= value; }
     }
-
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Data/PreprocessingData.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Data/PreprocessingData.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Data/PreprocessingData.cs	(revision 15242)
@@ -33,12 +33,8 @@
   [Item("PreprocessingData", "Represents data used for preprocessing.")]
   public abstract class PreprocessingData : NamedItem, IPreprocessingData {
-
     public IntRange TrainingPartition { get; set; }
     public IntRange TestPartition { get; set; }
 
-    protected IList<ITransformation> transformations;
-    public IList<ITransformation> Transformations {
-      get { return transformations; }
-    }
+    public IList<ITransformation> Transformations { get; protected set; }
 
     protected IList<IList> variableValues;
@@ -85,5 +81,5 @@
       TrainingPartition = (IntRange)original.TrainingPartition.Clone(cloner);
       TestPartition = (IntRange)original.TestPartition.Clone(cloner);
-      transformations = new List<ITransformation>(original.transformations.Select(cloner.Clone));
+      Transformations = new List<ITransformation>(original.Transformations.Select(cloner.Clone));
 
       InputVariables = new List<string>(original.InputVariables);
@@ -97,5 +93,5 @@
       Name = "Preprocessing Data";
 
-      transformations = new List<ITransformation>();
+      Transformations = new List<ITransformation>();
       selection = new Dictionary<int, IList<int>>();
 
@@ -166,5 +162,4 @@
 
     #region IPreprocessingData Members
-
     public abstract T GetCell<T>(int columnIndex, int rowIndex);
 
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Data/TransactionalPreprocessingData.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Data/TransactionalPreprocessingData.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Data/TransactionalPreprocessingData.cs	(revision 15242)
@@ -33,5 +33,4 @@
   [Item("PreprocessingData", "Represents data used for preprocessing.")]
   public class TransactionalPreprocessingData : PreprocessingData, ITransactionalPreprocessingData {
-
     private class Snapshot {
       public IList<IList> VariableValues { get; set; }
@@ -70,5 +69,5 @@
         TrainingPartition = new IntRange(TrainingPartition.Start, TrainingPartition.End),
         TestPartition = new IntRange(TestPartition.Start, TestPartition.End),
-        Transformations = new List<ITransformation>(transformations),
+        Transformations = new List<ITransformation>(Transformations),
         ChangedType = changedType,
         ChangedColumn = column,
@@ -83,13 +82,10 @@
 
     #region NamedItem abstract Member Implementations
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new TransactionalPreprocessingData(this, cloner);
     }
-
     #endregion
 
     #region Overridden IPreprocessingData Members
-
     public override T GetCell<T>(int columnIndex, int rowIndex) {
       return (T)variableValues[columnIndex][rowIndex];
@@ -216,5 +212,4 @@
     }
 
-
     public override void InsertRow(int rowIndex) {
       SaveSnapshot(DataPreprocessingChangedEventType.DeleteRow, -1, rowIndex);
@@ -346,5 +341,4 @@
 
     #region TransactionalPreprocessingData members
-
     public bool IsUndoAvailable {
       get { return undoHistory.Count > 0; }
@@ -358,5 +352,5 @@
         TrainingPartition = previousSnapshot.TrainingPartition;
         TestPartition = previousSnapshot.TestPartition;
-        transformations = previousSnapshot.Transformations;
+        Transformations = previousSnapshot.Transformations;
         undoHistory.Remove(previousSnapshot);
         OnChanged(previousSnapshot.ChangedType,
@@ -384,5 +378,4 @@
       OnChanged(@event, -1, -1);
     }
-
     #endregion
   }
